/* $Id: isdn_v110.h,v 1.4 2000/05/19 20:43:08 thockin Exp $

 * Linux ISDN subsystem, V.110 related functions (linklevel).
 *
 * Copyright by Thomas Pfeiffer (pfeiffer@pds.de)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Log: isdn_v110.h,v $
 * Revision 1.4  2000/05/19 20:43:08  thockin
 * This is the 2.2.15 BASELINE.  It has virgin 2.2.15 plus:
 * 	ide patch
 * 	usb patch
 * 	national ethernet patch
 * 	raid0145
 * 	raidwo
 *
 * These are all patches we don't maintain (well, kindof).  After this I will
 * add all our patches.  This way we can diff this baseline against HEAD and
 * get a list of OUR changes.  Capisch?
 *
 * Revision 1.3  2000/03/16 16:34:12  kai
 * some translation work
 *
 * there shouldn't be any German comments lurking around anymore ;-)
 *
 * Revision 1.2  1999/10/30 09:49:28  keil
 * Reinit of v110 structs
 *
 * Revision 1.1  1998/02/20 17:32:11  fritz
 * First checkin (not yet completely functionable).
 *
 */
#ifndef _isdn_v110_h_
#define _isdn_v110_h_

/* 
 * isdn_v110_encode will take raw data and encode it using V.110 
 */
extern struct sk_buff *isdn_v110_encode(isdn_v110_stream *, struct sk_buff *);

/* 
 * isdn_v110_decode receives V.110 coded data from the stream and rebuilds
 * frames from them. The source stream doesn't need to be framed.
 */
extern struct sk_buff *isdn_v110_decode(isdn_v110_stream *, struct sk_buff *);

extern int isdn_v110_stat_callback(int, isdn_ctrl *);
extern void isdn_v110_close(isdn_v110_stream * v);

#endif
