#ifndef __LINUX_COBALT_I2C_H
#define __LINUX_COBALT_I2C_H 1

#include <linux/types.h>

#define COBALT_I2C_TYPE_UNKNOWN  0
#define COBALT_I2C_TYPE_GEN_III  1
#define COBALT_I2C_TYPE_GEN_V    2

#define COBALT_I2C_DEV_LED_I     0x40
#define COBALT_I2C_DEV_LED_II    0x42
#define COBALT_I2C_DEV_LCD_DATA  0x4a
#define COBALT_I2C_DEV_LCD_INST  0x48
#define COBALT_I2C_DEV_BUTTON    0x41
#define COBALT_I2C_DEV_SWITCH    0x45
#define COBALT_I2C_DEV_RULER     0x46
#define COBALT_I2C_DEV_TEMP      0x90

#define COBALT_I2C_READ          0x01
#define COBALT_I2C_WRITE         0x00

extern int cobalt_i2c_type(void);
extern int cobalt_i2c_read_byte(const int, const int);
extern int cobalt_i2c_read_word(const int, const int);
extern int cobalt_i2c_read_block(const int, const int, unsigned char *, int);

extern int cobalt_i2c_write_byte(const int, const int, const u8);
extern int cobalt_i2c_write_word(const int, const int, const u16);
extern int cobalt_i2c_write_block(const int, const int, unsigned char *, int);
extern int cobalt_i2c_reset(void);
#endif
